----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:28:19 04/25/2007 
-- Design Name: 
-- Module Name:    oslb_sim - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity oslb_sim is
    Port ( TP_a : in std_logic_vector(35 downto 0);
           TP_b : in std_logic_vector(35 downto 0);
-- loc_spare signals are unused and grounded by CPLD
           loc_bus : inout std_logic_vector(7 downto 0);
           loc_add : in std_logic_vector(6 downto 0);
           loc_rw : in std_logic;
           loc_cs : in std_logic;
           maddr : out std_logic_vector(18 downto 0);
           mdata : inout std_logic_vector(7 downto 0);
           moe_b : out std_logic;
           mce_b : out std_logic;
           mwe_b : out std_logic;
			  prog_b : out std_logic;
			  cs_b : out std_logic;
			  rdwr_b : out std_logic;
           done : in std_logic;
           ttc_brcst : in std_logic_vector(7 downto 2);
           ttc_brcst_strb : in std_logic;
           ttc_clk_des : in std_logic;
           ttc_bcr : in std_logic;
           rx_bc0_p : in std_logic;
           rx_bc0_n : in std_logic;
           rx_clk_p : in std_logic;
           rx_clk_n : in std_logic;
           GOL_ready : in std_logic_vector(2 downto 0);
           GOL0_data : out std_logic_vector(31 downto 0);
           GOL1_data : out std_logic_vector(31 downto 0);
           GOL2_data : out std_logic_vector(31 downto 0);
           GOL0_flag : out std_logic_vector(1 downto 0);
           GOL1_flag : out std_logic_vector(1 downto 0);
           GOL2_flag : out std_logic_vector(1 downto 0);
           GOL_reset_b : out std_logic_vector(2 downto 0);
           GOL_negedge : out std_logic;
           GOL_cav : out std_logic_vector(2 downto 0);
           GOL_dav : out std_logic_vector(2 downto 0);
           GOL_FF : out std_logic_vector(2 downto 0);
           GOL_SCL : out std_logic_vector(2 downto 0);
           GOL_SDA : inout std_logic;
           QPLL_locked : in std_logic;
           QPLL_err : in std_logic;
           QPLL_reset_b : out std_logic;
           CB_SI : out std_logic;
           CB_EN : out std_logic;
           CB_CK : out std_logic;
           GLINK : out std_logic
      );
end oslb_sim;

architecture Behavioral of oslb_sim is
component OSLB
    Port ( TP_a : in std_logic_vector(35 downto 0);
           TP_b : in std_logic_vector(35 downto 0);
           loc_bus : inout std_logic_vector(7 downto 0);
           loc_add : in std_logic_vector(6 downto 0);
           loc_rw : in std_logic;
           loc_cs : in std_logic;
           loc_spare : in std_logic_vector(7 downto 0);
           loc_ctrl : out std_logic_vector(2 downto 0);
           init_b : out std_logic;
-- loc_spare signals are unused and grounded by CPLD
           ttc_brcst : in std_logic_vector(7 downto 2);
           ttc_brcst_strb : in std_logic;
           ttc_clk_des : in std_logic;
           ttc_bcr : in std_logic;
           rx_bc0_p : in std_logic;
           rx_bc0_n : in std_logic;
           rx_clk_p : in std_logic;
           rx_clk_n : in std_logic;
           GOL_ready : in std_logic_vector(2 downto 0);
           GOL0_data : out std_logic_vector(31 downto 0);
           GOL1_data : out std_logic_vector(31 downto 0);
           GOL2_data : out std_logic_vector(31 downto 0);
           GOL0_flag : out std_logic_vector(1 downto 0);
           GOL1_flag : out std_logic_vector(1 downto 0);
           GOL2_flag : out std_logic_vector(1 downto 0);
           GOL_reset_b : out std_logic_vector(2 downto 0);
           GOL_negedge : out std_logic;
           GOL_cav : out std_logic_vector(2 downto 0);
           GOL_dav : out std_logic_vector(2 downto 0);
           GOL_FF : out std_logic_vector(2 downto 0);
           GOL_SCL : out std_logic_vector(2 downto 0);
           GOL_SDA : inout std_logic;
           QPLL_locked : in std_logic;
           QPLL_err : in std_logic;
           QPLL_reset_b : out std_logic;
           CB_SI : out std_logic;
           CB_EN : out std_logic;
           CB_CK : out std_logic;
           GLINK : out std_logic
			  );
end component;
component oslb_cpld
    Port ( 
           loc_add : in std_logic_vector(6 downto 0);
           loc_add_out : out std_logic_vector(6 downto 0);
           loc_bus : inout std_logic_vector(7 downto 0);
           loc_rw : in std_logic;
           loc_cs : in std_logic;
           spare3 : out std_logic;
           spare5 : out std_logic;
           maddr : out std_logic_vector(18 downto 0);
           mdata : inout std_logic_vector(7 downto 0);
           moe_b : out std_logic;
           mce_b : out std_logic;
           mwe_b : out std_logic;
           cclk_fb : in std_logic;
           cclk_fbp : out std_logic;
           cclk : in std_logic;
           cclkp : out std_logic;
			  prog_b : out std_logic;
			  cs_b : out std_logic;
			  rdwr_b : out std_logic;
           init_b : in std_logic;
           done : in std_logic;
           ctrl_in : in std_logic_vector(2 downto 0)
			  );
end component;
signal loc_spare : std_logic_vector(7 downto 0);
signal loc_ctrl : std_logic_vector(2 downto 0);
signal loc_addp : std_logic_vector(6 downto 0);
signal init_b : std_logic;
signal cclk : std_logic;
signal cclk_fb : std_logic := '0';
signal cclk_fbp : std_logic;
begin
cclk_fb <= not cclk_fb after 10ns;
i_oslb_cpld: oslb_cpld port map(
		loc_bus => loc_bus,
		loc_add => loc_add,
		loc_add_out => loc_addp,
		loc_rw => loc_rw,
		loc_cs => loc_cs,
		ctrl_in => loc_ctrl,
		init_b => init_b,
		maddr => maddr,
		mdata => mdata,
		moe_b => moe_b,
		mce_b => mce_b,
		mwe_b => mwe_b,
		cclk_fb => cclk_fb,
		cclk_fbp => cclk_fbp,
		cclk => cclk,
		cclkp => cclk,
		prog_b => prog_b,
		cs_b => cs_b,
		spare3 => loc_spare(3),
		spare5 => loc_spare(5),
		rdwr_b => rdwr_b,
		done => done
		);
i_OSLB: OSLB PORT MAP(
		TP_a => TP_a,
		TP_b => TP_b,
		loc_bus => mdata,
		loc_add => loc_addp,
		loc_rw => loc_rw,
		loc_cs => loc_cs,
		loc_ctrl => loc_ctrl,
		init_b => init_b,
		loc_spare => loc_spare,
		ttc_brcst => ttc_brcst,
		ttc_brcst_strb => ttc_brcst_strb,
		ttc_clk_des => ttc_clk_des,
		ttc_bcr => ttc_bcr,
		rx_bc0_p => rx_bc0_p,
		rx_bc0_n => rx_bc0_n,
		rx_clk_p => rx_clk_p,
		rx_clk_n => rx_clk_n,
		GOL_ready => GOL_ready,
		GOL0_data => GOL0_data,
		GOL1_data => GOL1_data,
		GOL2_data => GOL2_data,
		GOL0_flag => GOL0_flag,
		GOL1_flag => GOL1_flag,
		GOL2_flag => GOL2_flag,
		GOL_reset_b => GOL_reset_b,
		GOL_negedge => GOL_negedge,
		GOL_cav => GOL_cav,
		GOL_dav => GOL_dav,
		GOL_FF => GOL_FF,
		GOL_SCL => GOL_SCL,
		GOL_SDA => GOL_SDA,
		QPLL_locked => QPLL_locked,
		QPLL_err => QPLL_err,
		QPLL_reset_b => QPLL_reset_b,
		CB_SI => CB_SI,
		CB_EN => CB_EN,
		CB_CK => CB_CK,
		GLINK => GLINK
	);


end Behavioral;

